



Const RAM_A17_A16_Reg = 0 'A17...A16    R/W
Const RAM_Hi_Reg      = 1 'A15...A8     R/W
Const RAM_Lo_Reg      = 2 'A7...A0      R/W
Const RAM_Data_Reg    = 3 'D7...D0      R/W

Const LCD_Enable_Reg  = 4
'DEFAULT-> 0  0  x  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> text_layer    0=disable 1=enable
         ' |  |  |  |  |  |  \----> layer0        0=disable 1=enable
         ' |  |  |  |  |  \-------> layer1        0=disable 1=enable
         ' |  |  |  |  \----------> layer2        0=disable 1=enable
         ' |  |  |  \-------------> layer3        0=disable 1=enable
         ' |  |  \----------------> nc
         ' |  \-------------------> LCD inverse   0=normal  1=invers
         ' \----------------------> LCD_DISP_OFF  0=disable 1=enable
         '
Const Graphics_Mode_Reg  = 5   'RW
'DEFAULT-> x  x  x  x  0  1  1  1   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0   R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> graph_blink_rate[0]
         ' |  |  |  |  |  |  \----> graph_blink_rate[1]
         ' |  |  |  |  |  \-------> graph_blink_rate[2]
         ' |  |  |  |  \----------> graph_blink_rate[3]
         ' |  |  |  \-------------> nc
         ' |  |  \----------------> nc
         ' |  \-------------------> nc
         ' \----------------------> nc

Const Layer0_Mode_Reg = 6
'DEFAULT-> x  x  0  0  0  1  1  1    R/W
         'b7 b6 b5 b4 b3 b2 b1 b0
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> layer_bright[0]
         ' |  |  |  |  |  |  \----> layer_bright[1]
         ' |  |  |  |  |  \-------> layer_mode       0=1bit/pixel 1=2bit/pixel
         ' |  |  |  |  \----------> layer_blink_en   0=tiltva, 1=villogas engedelyezve
         ' |  |  |  \-------------> layer_blink_inv  0=normal, 1=ellenutemu villogas
         ' |  |  \----------------> layer_mask_en    0=normal, 1=kitakar ( Layer0-nal nincs )
         ' |  \-------------------> nc
         ' \----------------------> nc
         '
'Layer0 RESET utani kezdocime = 2400 ( &H960 )
Const Layer0_Start_H_Reg = 7    'A16...A9   R/W
Const Layer0_Start_L_Reg = 8    ' A8...A1   R/W

Const Layer1_Mode_Reg     = 9    'R/W ( ugyanaz mint a Layer0-nal )
'Layer1 RESET utani kezdocime = 21600 ( &H2460 )
Const Layer1_Start_H_Reg = 10    'A16...A9   R/W
Const Layer1_Start_L_Reg = 11   ' A8...A1   R/W

Const Layer2_Mode_Reg     = 12   'R/W ( ugyanaz mint a Layer0-nal )
'Layer2 RESET utani kezdocime = 40800 ( &H9F60 )
Const Layer2_Start_H_Reg = 13   'A16...A9   R/W
Const Layer2_Start_L_Reg = 14   ' A8...A1   R/W

Const Layer3_Mode_Reg     = 15   'R/W ( ugyanaz mint a Layer0-nal )
'Layer3 RESET utani kezdocime = 60000 ( &HEA60 )
Const Layer3_Start_H_Reg = 16   'A16...A9   R/W
Const Layer3_Start_L_Reg = 17   ' A8...A1   R/W

Const LayerX_Mode_Reg     = 18   'R/W ( ugyanaz mint a Layer0-nal )
'LayerX RESET utani kezdocime = 79200 ( &H13560 )
Const LayerX_Start_H_Reg = 19   'A16...A9   R/W
Const LayerX_Start_L_Reg = 20   ' A8...A1   R/W


Const Text_Mode_Reg = 21
'DEFAULT-> 0  1  1  1  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0   R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> char_gen_size ( 0=8 1=12 )
         ' |  |  |  |  |  |  \----> char_size[0]  ( 0=8 ... 7=15 )
         ' |  |  |  |  |  \-------> char_size[1]
         ' |  |  |  |  \----------> char_size[2]
         ' |  |  |  \-------------> blink_rate[0]
         ' |  |  \----------------> blink_rate[1]
         ' |  \-------------------> blink_rate[2]
         ' \----------------------> blink_rate[3]
         '
'Text layer RESET utani kezdocime = 0 ( &H0 )
Const Text_Start_H_Reg = 22  'A16...A9   R/W
Const Text_Start_L_Reg = 23  ' A8...A1   R/W

'Ext CRGAM RESET utani kezdocime  = 98400 ( &H18060 )
Const Ext_CGRAM_Start_Addr_H_Reg = 24 'A16...A9   R/W
Const Ext_CGRAM_Start_Addr_L_Reg = 25 ' A8...A1   R/W


'*******************************
'**     GPU regiszterek     **
'*******************************


'X Y automatikus leptetes
Const YX_Auto_INC_Reg      = 26  'R/W
'DEFAULT-> 0  0  0  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0   R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> x_inc[0]
         ' |  |  |  |  |  |  \----> x_inc[1]
         ' |  |  |  |  |  \-------> x_inc[2]
         ' |  |  |  |  \----------> x_inc_sig
         ' |  |  |  \-------------> y_inc[0]
         ' |  |  \----------------> y_inc[1]
         ' |  \-------------------> y_inc[2]
         ' \----------------------> y_inc_sig
         '

Const Dashed_Pattern_H_Reg     = 27  'R/W
Const Dashed_Pattern_L_Reg     = 28  'R/W
Const Pattern_Pointer_Reg      = 29  'R/W


'RESET utani alapertek  = 0 ( &H0 ) R/W
Const GPU_Function_Reg            = 30 ' bit[3:0] Pixel_write_mode
                                       '     0 Normal
                                       '     1 Overwrite
                                       '     2 OR
                                       '     3 XOR
                                       '     4 AND
                                       '     5 INVERZ
                                       '     6 Bright DEC
                                       '     7 Bright INC
                                       ' bit[7:4] Function_select
                                       '     0 Pont
                                       '     1 Vonal
                                       '     2 Kor
                                       '     3 Blokk

Const X_H_Reg       = 31 ' x[8]     R/W
Const X_L_Reg       = 32 ' x[7:0]   R/W
Const X_Reg         = 33 ' y[7:0]   R/W
Const X1_H_Reg      = 34 ' x1[8]    R/W
Const X1_L_Reg      = 35 ' x1[7:0]  R/W
Const Y1_Reg        = 36 ' y1[7:0]  R/W

'RESET utani alapertek  = 0 ( &H0 )
Const Plot_Data_Reg = 37 '
         'b7 b6 b5 b4 b3 b2 b1 b0
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> pixel_bright[0]      R/W
         ' |  |  |  |  |  |  \----> pixel_bright[1]      R/W
         ' |  |  |  |  |  \-------> sprite_pixel_attr    R/W  0=atlatszo, 1 nem atlatszo
         ' |  |  |  |  \----------> layer_select[0]      R/W
         ' |  |  |  \-------------> layer_select[1]      R/W
         ' |  |  \----------------> layer_select[2]      R/W
         ' |  \-------------------> sprite_attr_en       R/W
         ' \----------------------> point_start          WO  plot_point_ready RO
         '
'RESET utani alapertek  = 0 ( &H0 )
Const Line_Draw_Data_Reg = 38
         'b7 b6 b5 b4 b3 b2 b1 b0
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \->  pixel_bright[0]      R/W
         ' |  |  |  |  |  |  \---->  pixel_bright[1]      R/W
         ' |  |  |  |  |  \------->  sprite_pixel_attr    R/W 0=atlatszo, 1 nem atlatszo
         ' |  |  |  |  \---------->  layer_select[0]      R/W
         ' |  |  |  \------------->  layer_select[1]      R/W
         ' |  |  \---------------->  layer_select[2]      R/W
         ' |  \------------------->  sprite_attr_en       R/W
         ' \---------------------->  line_draw_ready  RO( csak olvashato ! )
         '
'RESET utani alapertek  = 0 ( &H0 )
Const Circle_Draw_Data_Reg = 39
         'b7 b6 b5 b4 b3 b2 b1 b0
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \->  pixel_bright[0]      R/W
         ' |  |  |  |  |  |  \---->  pixel_bright[1]      R/W
         ' |  |  |  |  |  \------->  sprite_pixel_attr    R/W 0=atlatszo, 1 nem atlatszo
         ' |  |  |  |  \---------->  layer_select[0]      R/W
         ' |  |  |  \------------->  layer_select[1]      R/W
         ' |  |  \---------------->  layer_select[2]      R/W
         ' |  \------------------->  sprite_attr_en       R/W
         ' \---------------------->  circle_ready         RO( csak olvashato ! )
         '
Const Block_Mode_Reg = 40
'DEFAULT-> X  X  X  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0    R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \->  block_mode[0] R/W  0=Normal, 1=MOVE
         ' |  |  |  |  |  |  \---->  block_mode[1] R/W  0=Normal, 1=FILL
         ' |  |  |  |  |  \------->  block_mode[2] R/W  0=MIRROR, 1=ROTATE
         ' |  |  |  |  \---------->  block_mode[3] R/W
         ' |  |  |  \------------->  block_mode[4] R/W
         ' |  |  \---------------->
         ' |  \------------------->
         ' \---------------------->
         '
         ' Ha a 2.bit = 0 ( MIRROR ) akkor bit[4:3]  0= no mirror
                                                   ' 1= x mirror
                                                   ' 2= y mirror
                                                   ' 3= xy mirror
         ' Ha a 2.bit = 0 ( ROTATE ) akkor bit[4:3]  0=   0 deg rotate
                                                   ' 1=  90 deg rotate
                                                   ' 2= 180 deg rotate
                                                   ' 3= 270 deg rotate

Const Block_Width_H_Reg      = 41  'block_width[8]      R/W
Const Block_Width_L_Reg      = 42  'block_width[7:0]    R/W
Const Block_Height_Reg       = 43  'block_height[7:0]   R/W
Const Block_Layer_Select_Seg = 44
         'b7 b6 b5 b4 b3 b2 b1 b0
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \->  source_layer[0]   R/W
         ' |  |  |  |  |  |  \---->  source_layer[1]   R/W
         ' |  |  |  |  |  \------->  source_layer[2]   R/W
         ' |  |  |  |  \---------->  target_layer[0]   R/W
         ' |  |  |  \------------->  target_layer[1]   R/W
         ' |  |  \---------------->  target_layer[2]   R/W
         ' |  \------------------->  block_fill_bright[0] WO
         ' \---------------------->  block_fill_bright[1] WO / block_ready  RO
         '

Const Max_Plot_Ct_H_Reg    = 45  ' Max_Plot_Ct[8]
Const Max_Plot_Ct_L_Reg    = 46  ' Max_Plot_Ct[7:0]

'*******************************
'**     SPRITE regiszterek     **
'*******************************
Const Sprite0_Width    = 60  'sprite0_width[6:0]  =  Width + 1   byte-okban R/W
Const Sprite0_Height   = 61  'sprite0_height[7:0] =  Height + 1  pixel-ben  R/W

Const Sprite0_X_H_Reg  = 62   'x[8]
Const Sprite0_X_L_Reg  = 63   'x[7:0]
Const Sprite0_Y_Reg    = 64   'y[7:0]

Const Sprite1_Width    = 65  'sprite1_width[6:0]  =  Width + 1   byte-okban R/W
Const Sprite1_Height   = 66  'sprite1_height[7:0] =  Height + 1  pixel-ben  R/W

Const Sprite1_X_H_Reg  = 67  'x[8]
Const Sprite1_X_L_Reg  = 68  'x[7:0]
Const Sprite1_Y_Reg    = 69  'y[7:0]

Const Sprite2_Width    = 70  'sprite2_width[6:0]  =  Width + 1   byte-okban R/W
Const Sprite2_Height   = 71  'sprite2_height[7:0] =  Height + 1  pixel-ben  R/W

Const Sprite2_X_H_Reg  = 72  'x[8]
Const Sprite2_X_L_Reg  = 73  'x[7:0]
Const Sprite2_Y_Reg    = 74  'y[7:0]

Const Sprite_Enable_Reg = 75
'DEFAULT-> 0  0  0  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0    R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \->  Sprite0_En       R/W  0=Disable, 1=Enable
         ' |  |  |  |  |  |  \---->  Sprite0_Attr_en  R/W  0=Disable, 1=Enable
         ' |  |  |  |  |  \------->  Sprite1_En       R/W  0=Disable, 1=Enable
         ' |  |  |  |  \---------->  Sprite1_Attr_en  R/W  0=Disable, 1=Enable
         ' |  |  |  \------------->  Sprite2_En       R/W  0=Disable, 1=Enable
         ' |  |  \---------------->  Sprite2_Attr_en  R/W  0=Disable, 1=Enable
         ' |  \------------------->
         ' \---------------------->
         '


'*******************************
'**     I/O regiszterek     **
'*******************************

Const PORT0_OUT_Reg = 128 'R/W
Const PORT0_IN_Reg  = 129 'R/W
Const PORT0_DIR_Reg = 130 'R/W

Const PORT1_OUT_Reg = 132 'R/W
Const PORT1_IN_Reg  = 133 'R/W
Const PORT1_DIR_Reg = 134 'R/W

Const PORT2_OUT_Reg = 136 'R/W
Const PORT2_IN_Reg  = 137 'R/W
Const PORT2_DIR_Reg = 138 'R/W
Const PORT2_ALT_Reg = 139 'R/W

Const PORT3_OUT_Reg = 140 'R/W
Const PORT3_IN_Reg  = 141 'R/W
Const PORT3_DIR_Reg = 142 'R/W
Const PORT3_ALT_Reg = 143 'R/W


Const ENCODER0_POS_Reg = 145 'R/W
Const ENCODER1_POS_Reg = 146 'R/W
Const ENCODER2_POS_Reg = 147 'R/W
Const ENCODER3_POS_Reg = 148 'R/W
Const ENCODER_MODE_Reg = 149 'R/W
'DEFAULT-> 0  0  0  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0    R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \->  ENC0_MODE  R/W  \
         ' |  |  |  |  |  |  \---->  ENC1_MODE  R/W   \__ 0 = Overflow enable
         ' |  |  |  |  |  \------->  ENC2_MODE  R/W   /   1 = Overflow disable
         ' |  |  |  |  \---------->  ENC3_MODE  R/W  /
         ' |  |  |  \------------->  ENC0_DIR   R/W  \
         ' |  |  \---------------->  ENC1_DIR   R/W   \__ 0 = POSITION INCREMENT
         ' |  \------------------->  ENC2_DIR   R/W   /   1 = POSITION DECREMENT
         ' \---------------------->  ENC3_DIR   R/W  /
         '
Const ENCODER_TYPE_Reg = 150 'R/W
'DEFAULT-> 0  0  0  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0    R/W
         '             |  |  |  |
         '             |  |  |  \->  ENC0_TYPE  R/W  0 = normal, 1 = EC85
         '             |  |  \---->  ENC1_TYPE  R/W  0 = normal, 1 = EC85
         '             |  \------->  ENC2_TYPE  R/W  0 = normal, 1 = EC85
         '             \---------->  ENC3_TYPE  R/W  0 = normal, 1 = EC85


'*******************************
'**      PWM regiszterek      **
'*******************************

'8 bit-es PWM
Const PWM0_8_Reg     = 151  ' PWM0 R/W    adatregiszterek
Const PWM1_8_Reg     = 152  ' PWM1 R/W    adatregiszterek
Const PWM2_8_Reg     = 153  ' PWM2 R/W    adatregiszterek
Const PWM_8_DIV_Reg  = 154  ' PWM  R/W    0, 1, 2 elooszto
Const PWM3_8_Reg     = 155  ' PWM3 R/W    Adatregiszter
Const PWM3_8_DIV_Reg = 156  ' PWM3 R/W    elooszto

'12 bit-es PWM
Const PWM4_12_H_Reg  = 157  ' PWM4 R/W    adatregiszter felso 4 bit
Const PWM4_12_L_Reg  = 158  ' PWM4 R/W    adatregiszter also byte
Const PWM5_12_H_Reg  = 159  ' PWM5 R/W    adatregiszter felso 4 bit
Const PWM5_12_L_Reg  = 160  ' PWM5 R/W    adatregiszter also byte
Const PWM6_12_H_Reg  = 161  ' PWM6 R/W    adatregiszter felso 4 bit
Const PWM6_12_L_Reg  = 162  ' PWM6 R/W    adatregiszter also byte
Const PWM7_12_H_Reg  = 163  ' PWM7 R/W    adatregiszter felso 4 bit
Const PWM7_12_L_Reg  = 164  ' PWM7 R/W    adatregiszter also byte
Const PWM12_DIV_Reg  = 165  ' PWM 4, 5, 6, 7 R/W    elooszto


'*******************************
'**     SCOPE regiszterek     **
'*******************************

Const TRIGGER_LEVEL_Reg = 200 'R/W Trigger szint

Const TRIGGER_Reg       = 201 'R/W
'DEFAULT-> 0  0  0  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0    R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> TRIGGER_POL  R/W  0 = "L"    1 = "H"
         ' |  |  |  |  |  |  \----> TRIGGER_MODE R/W  0 = Level  1 = Edge
         ' |  |  |  |  |  \-------> EXT_TRIGGER  R/W  0 = Int.   1 = Ext.
         ' |  |  |  |  \----------> PEAK_MODE    R/W  0 = Normal 1 = Peak detect
         ' |  |  |  \-------------> HYST[0] \
         ' |  |  \----------------> HYST[1]  \ __ Hiszterezis beallitas
         ' |  \-------------------> HYST[2]  /
         ' \----------------------> HYST[3] /
         '

Const TRIGGER_ADDR_H_Reg = 202 ' RO   Trigger cim felso 7 bit
Const TRIGGER_ADDR_L_Reg = 203 ' RO   Trigger cim also byte
Const TIME_DIV_2_Reg     = 204 ' R/W  Idoalap legfelso byte
Const TIME_DIV_1_Reg     = 205 ' R/W  Idoalap kozepso byte
Const TIME_DIV_0_Reg     = 206 ' R/W  Idoalap also byte
Const SAMPLE_LEN_H_Reg   = 207 ' R/W  Mintaveteli hossz felso byte
Const SAMPLE_LEN_L_Reg   = 208 ' R/W  Mintaveteli hossz also byte

Const SCOPE_STATUS_Reg   = 209
'DEFAULT-> 0  0  0  0  0  0  0  0
         'b7 b6 b5 b4 b3 b2 b1 b0
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> START         RO    TRIGGER_EN    WO
         ' |  |  |  |  |  |  \----> SAMPLE_GATE   RO    SAMPLE_CT_EN  WO
         ' |  |  |  |  |  \-------> WRITE_GATE    RO    WRITE_EN      WO
         ' |  |  |  |  \----------> WRITE_MODE    R/W
         ' |  |  |  \-------------> STOP          R/W
         ' |  |  \----------------> DIG_MODE      R/W
         ' |  \-------------------> SCOPE_IRQ_EN  R/W
         ' \----------------------> SCOPE_IRQ     RO
         '
Const SCOPE_W_ADDR_H_Reg = 210 'RO Minta ram iraskor a cimszregiszter felso 7 bit
Const SCOPE_W_ADDR_L_Reg = 211 'RO Minta ram iraskor a cimszregiszter also byte
Const DIG_MASK_Reg       = 212 'R/W Logikai analizator modban a bemenetek maszk
                               'regisztere. ha a bit 0, akkor a trigger nem veszi
                               'figyelembe, ha 1, akkor igen.

Const SCOPE_IRQ_ACK_Reg = 213 ' WO barmilyen iras ebbe a regiszterbe torli az
                              '    SCOPE_IRQ bit-et


'RESET utani alapertek  = 0 ( &H0 )
Const ADDR_AUTO_INC_Reg = 250 'R/W  -127...+127 Ram cursor automatikus novelese

Const Setup_Reg = 255
'DEFAULT-> 0  X  1  0  0  1  1  0   R/W  ( RESET utan 72Hz az LCD frissitesi freki )
         'b7 b6 b5 b4 b3 b2 b1 b0    R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \->  CPU RAM prioritas    R/W 0=high, 1=low
         ' |  |  |  |  |  |  \---->  LCD_Refress_Rate[0]  R/W
         ' |  |  |  |  |  \------->  LCD_Refress_Rate[1]  R/W
         ' |  |  |  |  \---------->  LCD_Refress_Rate[2]  R/W
         ' |  |  |  \------------->  LCD_Refress_Rate[3]  R/W
         ' |  |  \---------------->  LCD_Refress_Rate[4]  R/W
         ' |  \------------------->  ADC_SEQ              R/W
         ' \---------------------->  Screen_sapture_start R/W
         '

Const Reg_Select = 1
Const Reg_Data   = 0

' b7 b6 b5 b4 b3 b2 b1 b0 --> char_attr
'  |  ----- |  |  ----- |
'  |    |   |  |    |    ----> Ext karakter generator
'  |    |   |  |     --------> fenyero 0...3
'  |    |   |   -------------> atlatszosag. 0=igen, 1=nem
'  |    |    ----------------> inverz       0=nem,  1=igen
'  |     --------------------> villogas 0...3  0 = nem villog
'  |                                           1 = inverz villogas
'  |                                           2 = normal villogas
'  |                                           3 = kurzor villogas
'   -------------------------> Belso ext karakter genarator kivalasztasa