' $prog &HFF , &H0F , &HD9 , &H00                            ' generated. Take care that the chip supports all fuse bytes.
' $prog &HFF , &H8F , &HD9 , &H00                            ' 3.3V reset.

$regfile = "M644DEF.DAT"
$crystal = 20000000
$hwstack = 255
$swstack = 255
$framesize = 255

'A bootloader 115200 baud-ra van beallitva !!!


' V3 2011. marc. 13.
'
' 3_Mono_LCD.v -ig hasznalt
' CPU cimkivezetesek csokkentese elotti allapot
'-------------------------------------------------
' V4 2011. jun. 11.
'
' Constansok ertekeinek ujra kiosztasa
' Alap szubrutinok atirasa a CPU_RS cimvezetek nelkuli vezerleshez
' PLOT, BLOKK, LINE funkcional kulon van a pixel_write_mode regiszter
' Minden sprite mukodik
' I/O funkciok irasa elotti allapot
'
' V4.1 2011. Jul. 22.
'
' Regiszterek ujra kiosztasa, az egyszerusitett bevitel miatt.
' Bemeno parameter mindig az X, Y, X1, Y1 regiszter es a
' Pixel_write_mode reg-ben van, hogy mit csinaljon,
' ( pont, vonal, kor, blokk stb. )

' V4.2 2011 Aug. 10.
' Automatikus koordinata novelessel kibovitve
' Szakkagot rajzolas pattern regiszter hozzaadasa
' Regiszterek ujrakiosztasa
' Layer-ek villogtatasa
' Layer-ek lehetnek maszkok is

' V4.2 2011 Aug. 29.
' Scope funkcio es regiszterek ujrakiosztasa

' V5.0 2011 szep. 01.
' Scope funkciohoz uj probapanel keszitese es annak beuzemelese.
' PWM kontraszt szabalyozas az LCD-hez

' V5.1 2011 szep. 25.
' ATMEGA644-re atirva s tesztprogram megiras
' 3db CD4021 a billentyuzet kezeleshez
' Menurendszer a DEMO programhoz.

'***********************************************************
'***                                                     ***
'***    FPGA-val keszitett LCD vezerlo teszt program     ***
'***                                                     ***
'***                                                     ***
'***                                                     ***
'***                                                     ***
'***********************************************************
'** Megrendelo   : Sajat magam :-)                       ***
'** Verzio       : V5.1                                  ***
'** Start project: 2011.01.01.                           ***
'** End project  : 2011.09.25                            ***
'** Compiler     : BASCOM AVR V2.0.6.0                   ***
'***********************************************************
'                           __________   __________
'                           |         \_/         |
' 4021_clk             PB0 =| 1 (T0)     (ADC0) 40|= PA0  <-------------- Poti1
'                           |                     |
' 4021_strobe          PB1 =| 2 (T1)     (ADC1) 39|= PA1
'                           |                     |
' CD4021 Q8            PB2 =| 3 (AIN0)   (ADC2) 38|= PA2
'                           |                     |
'                      PB3 =| 4 (AIN1)   (ADC3) 37|= PA3
'                           |                     |
'                      PB4 =| 5 (SS)     (ADC4) 36|= PA4
'                           |                     |
'                      PB5 =| 6 (MOSI)   (ADC5) 35|= PA5 ------------> CPU_READY
'                           |                     |
'                      PB6 =| 7 (MISO)   (ADC6) 34|= PA6  ------------> CPU_BUSY
'                           |                     |
' 1WIRE <---------->   PB7 =| 8 (SCK)    (ADC7) 33|= PA7  ----------------> RS
'                           |                     |
' RESET  ----------> RESET =| 9                 32|= AREF <--------------- +5V
'                           |                     |
' +5V   ----------->   VCC =|10                 31|= GND  <--------------- GND
'                           |                     |
' GND   ----------->   GND =|11                 30|= AVCC <--------------- +5V
'                           |                     |
' Kvarc <----------- XTAL2 =|12         (TOSC2) 29|= PC7  <--------------> D7
'                           |                     |
' Kvarc -----------> XTAL1 =|13         (TOSC1) 28|= PC6  <--------------> D6
'                           |                     |
' Txd   ----------->   PD0 =|14 (RxD)     (TDI) 27|= PC5  <--------------> D5
'                           |                     |
' Rxd   <-----------   PD1 =|15 (TxD)     (TDO) 26|= PC4  <--------------> D4
'                           |                     |
' /CE  <-----------    PD2 =|16 (INT0)    (TMS) 25|= PC3  <--------------> D3
'                           |                     |
' /INT ------------>   PD3 =|17 (INT1)    (TCK) 24|= PC2  <--------------> D2
'                           |                     |
' LCD kontraszt PWM <--PD4 =|18 (OC1B)    (SDA) 23|= PC1  <--------------> D1
'                           |                     |
'                      PD5 =|19 (OC1A)    (SCL) 22|= PC0  <--------------> D0
' ______                    |                     |                        ______
' CPU_RD <----------   PD6 =|20 (ICP1)    (OC2) 21|= PD7  ---------------> CPU_WR
'                           |_____________________|
'



Config Porta.0 = input                                      'nc.
Config Porta.1 = Input                                      'nc.
Config Porta.2 = Input                                      'nc.
Config Porta.3 = input                                      'nc.
Config Porta.4 = Input                                      'nc.
Config Porta.5 = Input                                      'CPU_READY
Config Porta.6 = Input                                      'CPU_BUSY
Config Porta.7 = output                                     'CPU_RS


CPU_READY Alias pina.5
CPU_BUSY  Alias pina.6
CPU_RS    Alias porta.7



'----------------------------------------------------------------------




Portb = 255

Config Portb.0 = Output
Config Portb.1 = Output
Config Portb.2 = Input                                      'nc.
Config Portb.3 = Output
Config Portb.4 = Output                                      'nc.
Config Portb.5 = Input                                      'nc
Config Portb.6 = Input                                      'nc.
Config Portb.7 = Input                                      'nc.

CD4021_Clk     Alias PORTb.0
CD4021_Strobe  Alias PORTB.1
CD4021_Q8      Alias PINB.2


'----------------------------------------------------------------------
Portc = 0

Config Portd.0 = Input                                      'NC.
Config Portd.1 = Input                                      'NC.
Config Portd.2 = Output                                     'CPU_nCE
Config Portd.3 = Input                                      'CPU_nINT
Config Portd.4 = output                                      'NC.
Config Portd.5 = output                                      'NC.
Config Portd.6 = Output                                     'CPU_RD
Config Portd.7 = Output                                     'CPU_WR

CPU_CE  Alias PORTd.2
CPU_INT Alias pind.3
CPU_RD  Alias Portd.6
CPU_WR  Alias Portd.7




Portd = 255


CPU_CE = 0
'----------------------------------------------------------------------
Portc = 0

Config Portc = Output

CPU_Read_Data Alias Pinc
CPU_Write_Data Alias Portc

'----------------------------------------------------------------------

Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Down , Prescale = 1
PWM1B = 128 ' LCD kontraszt


'****************************************************************
'***              TIMER2 az idztsekhez                     ***
'****************************************************************
Config Timer2 = Timer , Prescale = 1024
Start Timer2
Enable Timer2
On Timer2 Timer2_it
Enable Interrupts


Config 1wire = Portb.7


Stop Watchdog

$Include "FPGA_REG.Bas"
$Include "SUB_DEF.BAS"





'FONTOS !!!!
'Az FPGA felprogramozasa miatt kell 500ms-os varakozas es csak
'utana lehet baszogatni a chip-et!
Waitms 500



Dim Port4021 As Long
Port4021 = &HFFFFFFFF

'
'
'A Nyomogombok elhelyezkedese a panelen
'
'                                ---            ---
'                              ( SB2 )        ( SB3 )
'NC.    ---------------   SW4    ---    SW11    ---     SW14
'      |               |
'SW1   |               |  SW5    SW9    SW10    SW12    SW13
'      |               |
'SW2   |               |  SW6    ---            ---
'      |               |       ( SB1 )        ( SB0 )
'SW3   |               |  SW7    ---    SW17    ---     SW20
'      |               |
'Reset  ---------------   SW8    SW15   SW16    SW18    SW19
'
'
'

SW1  Alias Port4021.2
SW2  Alias Port4021.3
SW3  Alias Port4021.1
SW4  Alias Port4021.6
SW5  Alias Port4021.5
SW6  Alias Port4021.0
SW7  Alias Port4021.4
SW8  Alias Port4021.7
SW9  Alias Port4021.11
SW10 Alias Port4021.14
SW11 Alias Port4021.13
SW12 Alias Port4021.12
SW13 Alias Port4021.8
SW14 Alias Port4021.10
SW15 Alias Port4021.19
SW16 Alias Port4021.22
SW17 Alias Port4021.21
SW18 Alias Port4021.16
SW19 Alias Port4021.20
SW20 Alias Port4021.18
SB2  Alias Port4021.15
SB3  Alias Port4021.9
SB1  Alias Port4021.23
SB0  Alias Port4021.17









Restart_Main:

$Include "FPGA_INIC.Bas"

DIM TTT AS WORD


DIM zzz AS Byte

Do
Loop Until Cpu_busy = 0




demo:

Szoveg = "(C)TUTIJO 2011. LCD FPGA CONTROLLER V5.1"
Lcd_SPrint 0, 0, 6
Szoveg = "Boot loader 11520 baud"
Lcd_SPrint 0, 1, 6



Szoveg = "      Scope teszt ->"
Lcd_SPrint 20, 2, 6
Szoveg = "        Demo Text ->"
Lcd_SPrint 20, 6, 6
Szoveg = "        Demo rajz ->"
Lcd_SPrint 20, 10, 6



Szoveg = "<- LCD kontraszt + "
Lcd_SPrint 0, 3, 6
Szoveg = "<- LCD kontraszt -"
Lcd_SPrint 0, 8, 6
Szoveg = "<- RETURN"
Lcd_SPrint 0, 13, 6
Szoveg = "<- RESET"
Lcd_SPrint 0, 18, 6


Do

'************ SCOPE TESZT ************************
If SW4 = 0 Then
   Do
   Loop Until SW4 = 1
   Scope_Teszt
   Goto Restart_Main
End If

'************ Demo Text ************************
If SW5 = 0 Then
   Do
   Loop Until SW5 = 1
   Demo_Text
   Goto Restart_Main
End If

'************ Demo Text ************************
If SW6 = 0 Then
   Do
   Loop Until SW6 = 1
   Clear_Ram
   Demo_Graphics
   Goto Restart_Main
End If



Loop




Stop



Timer2_It:
   Toggle Portb.3
   Check_Keyboard
   If SW2 = 0 And PWM1B < 255 Then Incr PWM1B
   If SW1 = 0 And PWM1B > 0 Then Decr PWM1B
   INCr TTT
Return



$Include "SUB_INC.Bas"
$Include "Scope_Teszt.Bas"
$Include "Demo_Text.Bas"

$Include "GRAPH_TESZT.Bas"
$include "MCS.PIC"
$include "Terkep.PIC"