Const Layer0     = 0
Const Layer1     = 1
Const Layer2     = 2
Const Layer3     = 3
Const LayerX     = 4
Const Sprite0    = 5
Const Sprite1    = 6
Const Sprite2    = 7
Const Text_Layer = 8

Const Dir_Right  = 0
Const Dir_Left   = 1
Const Dir_Up     = 2
Const Dir_Down   = 3
Const Roll       = 0
Const Scroll     = 1


Dim VRAM As Word           'A video RAM cimet ebbol olvassak a rutinok
Dim VRAM_A17_A16 As Byte   'A video RAM cimet ebbol olvassak a rutinok
Dim Szoveg As String * 40  'Az LCD_SPrint ebbol olvassa a kiirando karaktereket
Dim Karakter As String * 1 'Az LCD_SPRint hasznalja


Const BSize = 20     ' Az LCD_Fill rutin altal hasznalt stack merete

' Az LCD_Fill rutin FPGA-ban tarolt stack kezdocime
' Ha a stack-be adat kerul, akkor a stack cim novekszik
Const S_Addr = 36960

'A stack-ban tarolt adatstruktura Stack_St tomb cimzesere valo konstansok
Const S_YY  = 1
Const S_XL = 2
Const S_XR = 3
Const S_DY = 4
 'A stack-ben tarolt adatstruktura
Dim Stack_St( 4 ) As Integer

'A kepernyo koordinata hatarok
Dim MaxX       As Word
Dim MaxY       As Byte
MaxX = 319
MaxY = 239

'CPU belso memoriajaban levo stack
'A merete = BSize * 4 + 4
Dim IntStack ( 84 ) As Integer

Declare Sub LCD_Fill ( Byval FLayer As Byte, Byval FX As Word, Byval FY As Byte, Byval FBright As Byte )


Declare Sub Show_Picture (Byval P_Layer As Byte,  Byval PX1 as word, byval PY1 as byte )


'******************************************************************************
Declare Sub LCD_CLS ( Byval LX As Byte )
'Torli ( 0-val tolti fel ) a parameterben megadott layer-t.
'A parameter 0...8 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'Sprite0 = 5, Sprite1 = 6, Sprite2 = 7, Text_layer = 8
'******************************************************************************

'******************************************************************************
Declare Sub LCD_SPrint ( Byval SX  As Byte, Byval SY As Byte, Byval Text_Attr As Byte )
'A parameterben megadott koordinatara a "Szoveg" string valtozoban levo
'karaktereket irja ki a megadott attributumokkal.
'A "Szoveg" valtozo globalis!
'SX = X koordinata 0...40 ( a maximalis hatar nincs figyelve ! )
'SY = Y koordinata 0...30 ( a maximalis hatar nincs figyelve ! )
'Text_Attr = Karakter attributum
'             b7 b6 b5 b4 b3 b2 b1 b0 --> attributum
'              |  ----- |  |  ----- |
'              |    |   |  |    |    ----> Ext karakter generator
'              |    |   |  |     --------> fenyero 0...3
'              |    |   |   -------------> atlatszosag. 0=igen, 1=nem
'              |    |    ----------------> inverz       0=nem,  1=igen
'              |     --------------------> villogas 0...3  0 = nem villog
'              |                                           1 = inverz villogas
'              |                                           2 = normal villogas
'              |                                           3 = kurzor villogas
'               -------------------------> Belso ext karakter genarator kivalasztasa
'
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Circle_Draw ( Byval C_Layer As Byte , Byval Write_Mode As Byte, Byval Center_X As Word, Byval Center_Y As Byte , Byval Radius As Word, Byval Deg as byte, Byval C_Bright As Byte )
'Kort rajzol a megadott grafikus layer-re vagy Sprite-ra.
'C_Layer = 0...7 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'              Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'              Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'
'Write_Mode = 0 Normal
'             1 Overwrite
'             2 OR
'             3 XOR
'             4 AND
'             5 INVERZ
'             6 Bright DEC
'             7 Bright INC
'
'Center_X   = kor kozeppont X koordinata
'Center_Y   = kor kozeppont Y koordinata
'Radius     = kor sugara
'Deg        = a kor 1/8 reszeinek az engedelyezese vagy tiltasa 0=enged, 1=tilt
'C_Bright   = a kirajzolt pixelek fenyereje 0...3
'******************************************************************************
'******************************************************************************
Declare Sub LCD_Line_Draw ( Byval L_layer As Byte , Byval Write_Mode As Byte, Byval L_X As Word , Byval L_Y As Byte , Byval L_X1 As Word , Byval L_Y1 As Byte , Byval L_Bright As Byte )
'Vonalat rajzol a megadott grafikus layer-re vagy sprite-ra
'L_Layer = 0...7 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'              Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'              Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'
'Write_Mode = 0 Normal
'             1 Overwrite
'             2 OR
'             3 XOR
'             4 AND
'             5 INVERZ
'             6 Bright DEC
'             7 Bright INC
'
'L_X        = a vonal kezdopontjanak X koordinataja
'L_Y        = a vonal kezdopontjanak Y koordinataja
'L_X1       = a vonal vegpontjanak   X koordinataja
'L_Y1       = a vonal vegpontjanak   Y koordinataja
'L_Bright   = a kirajzolt pixelek fenyereje 0...3
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Count_Line_Draw  ( Byval L_Layer As Byte, Byval L_X As Word , Byval L_Y As Byte, Byval L_Bright As Byte )
'Az elozoleg rajzolt vonal vegpontjabol ujabb egyenes rajzolasa
'L_Layer = 0...7 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'              Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'              Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'
'Write_Mode = 0 Normal
'             1 Overwrite
'             2 OR
'             3 XOR
'             4 AND
'             5 INVERZ
'             6 Bright DEC
'             7 Bright INC
'
'L_X        = a vonal vegpontjanak X koordinataja
'L_Y        = a vonal vegpontjanak Y koordinataja
'L_Bright   = a kirajzolt pixelek fenyereje 0...3
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Plot ( Byval P_Layer As Byte , Byval Write_Mode As Byte, Byval P_X As Word , Byval P_Y As Byte , Byval P_Bright As Byte )
'Pixel rajzolas a megadott grafikus layer-re vagy sprite-ra
'P_Layer = 0...7 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'              Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'              Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'
'Write_Mode = 0 Normal
'             1 Overwrite
'             2 OR
'             3 XOR
'             4 AND
'             5 INVERZ
'             6 Bright DEC
'             7 Bright INC
'
'P_X        = a pixel X koordinataja
'P_Y        = a pixel Y koordinataja
'P_Bright   = a kirajzolt pixelek fenyereje 0...3
'******************************************************************************
'******************************************************************************
Declare Function LCD_Point ( Byval P_layer As Byte , Byval P_x As Word , Byval P_y As Byte ) As Byte
'Pixel fenyerejenek a kiolvasasa a megadott grafikus layer-rol vagy sprite-rol
'P_Layer = 0...7 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'              Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'              Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'
'P_X        = a pixel X koordinataja
'P_Y        = a pixel Y koordinataja
'LCD_Point  = b7 b6 b5 b4 b3 b2 b1 b0
'              0  0  0  0  0 |  |  |
'                            |  |  \-> pixel_bright[0]
'                            |  \----> pixel_bright[1]
'                            \-------> sprite_pixel_attr  0=atlatszo, 1 nem atlatszo
'******************************************************************************

'******************************************************************************
Declare Sub CPU_Write ( Byval RS As Byte , Byval Adat As Byte)
'Az FPGA adat vagy index regiszterenek irasa
'RS = 0...1 vagy az SUB_DEF.BAS-ban megadott konstansok
'           Reg_Data   = 0
'           Reg_Select = 1
'Adat = a kiirando adat
'******************************************************************************

'******************************************************************************
Declare Function CPU_Read  ( Byval RS As Byte) As Byte
'Az FPGA adat vagy index regiszterenek olvasasa
'RS = 0...1 vagy az SUB_DEF.BAS-ban megadott konstansok
'     Reg_Data   = 0
'     Reg_Select = 1
'******************************************************************************

'******************************************************************************
Declare Sub CPU_Poke ( Byval A17_A16 As Byte , Byval Address As Word , Byval Adat As Byte )
'FPGA belso vagy kulso RAM-jaba ir
'A17_A16 = a cimzes legfelso 2 bit-je
'Address = a cimzes also 16 bit-je
'Adat    = a kiirando adat
'******************************************************************************

'******************************************************************************
Declare Function CPU_Peek  ( Byval A17_A16 As Byte , Byval Address As Word ) As Byte
'FPGA belso vagy kulso RAM-jabol olvas
'A17_A16 = a cimzes legfelso 2 bit-je
'Address = a cimzes also 16 bit-je
'******************************************************************************

'******************************************************************************
Declare Sub Set_VRAM_Addr
'Az FPGA RAM cimzo regisytereibe berja a VRAM_A17_A16 es a VRAM globalis
'valtozokban megadott cimet.
'0. reg = VRAM_A17_A16
'1. reg = VRAM[15:8]
'2. reg = VRAM[7:0]
'******************************************************************************

'******************************************************************************
Declare Sub Clear_Ram
'Torli a 128kByte-os video RAM-ot. Az FPGA belso RAM-jaba nem ir.
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Set_Sprite_XY   ( Byval Sprite_Num As Byte, Byval Sprite_X As Word, Byval Sprite_Y As Byte  )
'Beallitja megadott sprite koordinatait
'Sprite_Num = 5...7 vagy az SUB_DEF.BAS-ban deklaralt konstansok
'                   Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'******************************************************************************
'******************************************************************************
Declare Sub LCD_Sprite_Enable  ( Byval Sprite_Num As Byte )
'Engedelyezi a sprite-ot
'Sprite_Num = 5...7 vagy az SUB_DEF.BAS-ban deklaralt konstansok
'                   Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Sprite_Disable ( Byval Sprite_Num As Byte )
'Tiltja a sprite-ot
'Sprite_Num = 5...7 vagy az SUB_DEF.BAS-ban deklaralt konstansok
'                   Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Set_Block_XY ( Byval W_Mode As Byte, Byval S_X As Word, Byval S_Y As Byte, Byval T_X As Word, Byval T_Y As Byte )
'A blokk masolas irasi modjat es a koordinatait allitja be
'Write_Mode = 0 Normal
'             1 Overwrite
'             2 OR
'             3 XOR
'             4 AND
'             5 INVERZ
'             6 Bright DEC
'             7 Bright INC
'
'S_X        = a forras terulet X koordinataja ( bal fellso sakor )
'S_Y        = a forras terulet Y koordinataja ( bal fellso sakor )
'T_X        = a cel terulet X koordinataja ( bal fellso sakor )
'T_Y        = a cel terulet Y koordinataja ( bal fellso sakor )
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Block ( Byval B_Mode As Byte, Byval B_Width As Word, Byval B_Height As Byte, Byval S_Layer As Byte, Byval T_Layer As Byte, Byval B_Bright As Byte )
'Blokk masolas
'B_Mode  = Blokk mod beallitasa
'         b7 b6 b5 b4 b3 b2 b1 b0    R/W
'          x  x  x  |  |  |  |  |
'                   |  |  |  |  \->  block_mode[0] 0=Normal, 1=MOVE
'                   |  |  |  \---->  block_mode[1] 0=Normal, 1=FILL
'                   |  |  \------->  block_mode[2] 0=MIRROR, 1=ROTATE
'                   |  \---------->  block_mode[3]
'                   \------------->  block_mode[4]
'
'          Ha a 2.bit = 0 ( MIRROR ) akkor bit[4:3]  0= no mirror
'                                                    1= x mirror
'                                                    2= y mirror
'                                                    3= xy mirror
'          Ha a 2.bit = 0 ( ROTATE ) akkor bit[4:3]  0=   0 deg rotate
'                                                    1=  90 deg rotate
'                                                    2= 180 deg rotate
'                                                    3= 270 deg rotate
'B_Width  = a blokk szelessege pixelekben 1....320
'B_Height = a blokk magassaga  pixelekben 1....240
'Az S_Layer es a T_Layer 0...7 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'              Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'              Sprite0 = 5, Sprite1 = 6, Sprite2 = 7
'S_Layer  = a forras layer vagy sprite 0...7
'T_Layer  = a cel layer vagy sprite    0...7
'B_Bright = MOVE funkcional a torolt pixel fenyereje
'           FILL funkcional a kitoltendo terulet pixelenek a fenyereje
'******************************************************************************

'******************************************************************************
Declare Sub LCD_Scroll_GLayer ( Byval S_Layer As Byte, Byval S_Dir As Byte, Byval S_Mode As Byte,  Byval S_Step As Word )
'A megadott grafikus layer teljes teruletet mozgatja
'S_Layer  = 0...4 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'           Layer0 = 0, Layer1 = 1, Layer2 = 2, Layer3 = 3, LayerX = 4
'
'S_Dir    = 0...3 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'                 0 = Dir_Right
'                 1 = Dir_Left
'                 2 = Dir_Up
'                 3 = Dir_Down
'
'S_Mode   = 0...1 lehet vagy az SUB_DEF.BAS-ban deklaralt konstansok
'                 0 = Roll    ( korbeforgatas )
'                 1 = Scroll  ( a kitolt resz torlodik )
'
'S_Step   = 1...320 lehet
'******************************************************************************

'******************************************************************************
Declare Sub Check_Keyboard
'3db CD4098-as shiftregiszter beolvasasa
'******************************************************************************
'******************************************************************************
Declare Sub Scope_Teszt
'******************************************************************************
'******************************************************************************
Declare Sub Demo_Text
'******************************************************************************
'******************************************************************************
Declare Sub Demo_Graphics
'******************************************************************************

